Index: drivers/filesystems/btrfs/security.c
===================================================================
--- drivers/filesystems/btrfs/security.c	(révision 75772)
+++ drivers/filesystems/btrfs/security.c	(copie de travail)
@@ -836,59 +692,49 @@
             return STATUS_INTERNAL_ERROR;
         }
     }
-    
+
+    if (!fcb || !ccb)
+        return STATUS_INVALID_PARAMETER;
+
     ExAcquireResourceExclusiveLite(fcb->Header.Resource, TRUE);
-    
-    if (fcb->subvol->root_item.flags & BTRFS_SUBVOL_READONLY) {
+
+    if (is_subvol_readonly(fcb->subvol, Irp)) {
         Status = STATUS_ACCESS_DENIED;
         goto end;
     }
-     
+
     oldsd = fcb->sd;
-    
-    Status = SeSetSecurityDescriptorInfo(NULL, &flags, sd, (void**)&fcb->sd, PagedPool, IoGetFileObjectGenericMapping());
-    
+
+    Status = SeSetSecurityDescriptorInfo(NULL, flags, sd, (void**)&fcb->sd, PagedPool, IoGetFileObjectGenericMapping());
+
     if (!NT_SUCCESS(Status)) {
         ERR("SeSetSecurityDescriptorInfo returned %08x\n", Status);
         goto end;
     }
-    
+
     ExFreePool(oldsd);
-    
+
     KeQuerySystemTime(&time);
     win_time_to_unix(time, &now);
-    
+
     fcb->inode_item.transid = Vcb->superblock.generation;
-    
+
     if (!ccb->user_set_change_time)
         fcb->inode_item.st_ctime = now;
-    
+
     fcb->inode_item.sequence++;
-    
-    if (flags & OWNER_SECURITY_INFORMATION) {
-        PSID owner;
-        BOOLEAN defaulted;
-        
-        Status = RtlGetOwnerSecurityDescriptor(sd, &owner, &defaulted);
-        
-        if (!NT_SUCCESS(Status)) {
-            ERR("RtlGetOwnerSecurityDescriptor returned %08x\n", Status);
-            goto end;
-        }
-        
-        fcb->inode_item.st_uid = sid_to_uid(owner);
-    }
-    
+
     fcb->sd_dirty = TRUE;
+    fcb->sd_deleted = FALSE;
     fcb->inode_item_changed = TRUE;
-    
+
     fcb->subvol->root_item.ctransid = Vcb->superblock.generation;
     fcb->subvol->root_item.ctime = now;
-    
+
     mark_fcb_dirty(fcb);
-    
-    send_notification_fcb(fileref, FILE_NOTIFY_CHANGE_SECURITY, FILE_ACTION_MODIFIED);
-    
+
+    send_notification_fcb(fileref, FILE_NOTIFY_CHANGE_SECURITY, FILE_ACTION_MODIFIED, NULL);
+
 end:
     ExReleaseResourceLite(fcb->Header.Resource);
 
@@ -895,7 +741,9 @@
     return Status;
 }
 
-NTSTATUS STDCALL drv_set_security(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp) {
+_Dispatch_type_(IRP_MJ_SET_SECURITY)
+_Function_class_(DRIVER_DISPATCH)
+NTSTATUS drv_set_security(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp) {
     NTSTATUS Status;
     PIO_STACK_LOCATION IrpSp = IoGetCurrentIrpStackLocation(Irp);
     PFILE_OBJECT FileObject = IrpSp->FileObject;
@@ -904,77 +752,161 @@
     ULONG access_req = 0;
     BOOL top_level;
 
-    TRACE("set security\n");
-    
     FsRtlEnterFileSystem();
 
+    TRACE("set security\n");
+
     top_level = is_top_level(Irp);
-    
-    if (Vcb && Vcb->type == VCB_TYPE_PARTITION0) {
-        Status = part0_passthrough(DeviceObject, Irp);
-        goto exit;
+
+    if (Vcb && Vcb->type == VCB_TYPE_VOLUME) {
+        Status = vol_set_security(DeviceObject, Irp);
+        goto end;
+    } else if (!Vcb || Vcb->type != VCB_TYPE_FS) {
+        Status = STATUS_INVALID_PARAMETER;
+        goto end;
     }
-    
+
     if (!ccb) {
         ERR("no ccb\n");
         Status = STATUS_INVALID_PARAMETER;
         goto end;
     }
-    
+
     Status = STATUS_SUCCESS;
-    
+
     Irp->IoStatus.Information = 0;
-    
-    if (IrpSp->Parameters.QuerySecurity.SecurityInformation & OWNER_SECURITY_INFORMATION) {
+
+    if (IrpSp->Parameters.SetSecurity.SecurityInformation & OWNER_SECURITY_INFORMATION) {
         TRACE("OWNER_SECURITY_INFORMATION\n");
         access_req |= WRITE_OWNER;
     }
 
-    if (IrpSp->Parameters.QuerySecurity.SecurityInformation & GROUP_SECURITY_INFORMATION) {
+    if (IrpSp->Parameters.SetSecurity.SecurityInformation & GROUP_SECURITY_INFORMATION) {
         TRACE("GROUP_SECURITY_INFORMATION\n");
         access_req |= WRITE_OWNER;
     }
 
-    if (IrpSp->Parameters.QuerySecurity.SecurityInformation & DACL_SECURITY_INFORMATION) {
+    if (IrpSp->Parameters.SetSecurity.SecurityInformation & DACL_SECURITY_INFORMATION) {
         TRACE("DACL_SECURITY_INFORMATION\n");
         access_req |= WRITE_DAC;
     }
 
-    if (IrpSp->Parameters.QuerySecurity.SecurityInformation & SACL_SECURITY_INFORMATION) {
+    if (IrpSp->Parameters.SetSecurity.SecurityInformation & SACL_SECURITY_INFORMATION) {
         TRACE("SACL_SECURITY_INFORMATION\n");
         access_req |= ACCESS_SYSTEM_SECURITY;
     }
-    
-    if ((ccb->access & access_req) != access_req) {
+
+    if (Irp->RequestorMode == UserMode && (ccb->access & access_req) != access_req) {
         Status = STATUS_ACCESS_DENIED;
         WARN("insufficient privileges\n");
         goto end;
     }
-    
+
     Status = set_file_security(DeviceObject->DeviceExtension, FileObject, IrpSp->Parameters.SetSecurity.SecurityDescriptor,
-                               IrpSp->Parameters.SetSecurity.SecurityInformation);
-    
+                               &IrpSp->Parameters.SetSecurity.SecurityInformation, Irp);
+
 end:
     Irp->IoStatus.Status = Status;
 
     IoCompleteRequest(Irp, IO_NO_INCREMENT);
-    
+
     TRACE("returning %08x\n", Status);
 
-exit:
-    if (top_level) 
+    if (top_level)
         IoSetTopLevelIrp(NULL);
 
     FsRtlExitFileSystem();
-    
+
     return Status;
 }
 
+static BOOL search_for_gid(fcb* fcb, PSID sid) {
+    LIST_ENTRY* le;
+
+    le = gid_map_list.Flink;
+    while (le != &gid_map_list) {
+        gid_map* gm = CONTAINING_RECORD(le, gid_map, listentry);
+
+        if (RtlEqualSid(sid, gm->sid)) {
+            fcb->inode_item.st_gid = gm->gid;
+            return TRUE;
+        }
+
+        le = le->Flink;
+    }
+
+    return FALSE;
+}
+
+void find_gid(struct _fcb* fcb, struct _fcb* parfcb, PSECURITY_SUBJECT_CONTEXT subjcont) {
+    NTSTATUS Status;
+    TOKEN_OWNER* to;
+    TOKEN_PRIMARY_GROUP* tpg;
+    TOKEN_GROUPS* tg;
+
+    if (parfcb && parfcb->inode_item.st_mode & S_ISGID) {
+        fcb->inode_item.st_gid = parfcb->inode_item.st_gid;
+        return;
+    }
+
+    ExAcquireResourceSharedLite(&mapping_lock, TRUE);
+
+    if (!subjcont || !subjcont->PrimaryToken || IsListEmpty(&gid_map_list)) {
+        ExReleaseResourceLite(&mapping_lock);
+        return;
+    }
+
+    Status = SeQueryInformationToken(subjcont->PrimaryToken, TokenOwner, (void**)&to);
+    if (!NT_SUCCESS(Status))
+        ERR("SeQueryInformationToken returned %08x\n", Status);
+    else {
+        if (search_for_gid(fcb, to->Owner)) {
+            ExReleaseResourceLite(&mapping_lock);
+            ExFreePool(to);
+            return;
+        }
+
+        ExFreePool(to);
+    }
+
+    Status = SeQueryInformationToken(subjcont->PrimaryToken, TokenPrimaryGroup, (void**)&tpg);
+    if (!NT_SUCCESS(Status))
+        ERR("SeQueryInformationToken returned %08x\n", Status);
+    else {
+        if (search_for_gid(fcb, tpg->PrimaryGroup)) {
+            ExReleaseResourceLite(&mapping_lock);
+            ExFreePool(tpg);
+            return;
+        }
+
+        ExFreePool(tpg);
+    }
+
+    Status = SeQueryInformationToken(subjcont->PrimaryToken, TokenGroups, (void**)&tg);
+    if (!NT_SUCCESS(Status))
+        ERR("SeQueryInformationToken returned %08x\n", Status);
+    else {
+        ULONG i;
+
+        for (i = 0; i < tg->GroupCount; i++) {
+            if (search_for_gid(fcb, tg->Groups[i].Sid)) {
+                ExReleaseResourceLite(&mapping_lock);
+                ExFreePool(tg);
+                return;
+            }
+        }
+
+        ExFreePool(tg);
+    }
+
+    ExReleaseResourceLite(&mapping_lock);
+}
+
 NTSTATUS fcb_get_new_sd(fcb* fcb, file_ref* parfileref, ACCESS_STATE* as) {
     NTSTATUS Status;
     PSID owner;
     BOOLEAN defaulted;
-    
+
     Status = SeAssignSecurityEx(parfileref ? parfileref->fcb->sd : NULL, as->SecurityDescriptor, (void**)&fcb->sd, NULL, fcb->type == BTRFS_TYPE_DIRECTORY,
                                 SEF_SACL_AUTO_INHERIT, &as->SubjectSecurityContext, IoGetFileObjectGenericMapping(), PagedPool);
 
@@ -982,7 +914,7 @@
         ERR("SeAssignSecurityEx returned %08x\n", Status);
         return Status;
     }
-    
+
     Status = RtlGetOwnerSecurityDescriptor(fcb->sd, &owner, &defaulted);
     if (!NT_SUCCESS(Status)) {
         ERR("RtlGetOwnerSecurityDescriptor returned %08x\n", Status);
@@ -990,6 +922,8 @@
     } else {
         fcb->inode_item.st_uid = sid_to_uid(owner);
     }
-    
+
+    find_gid(fcb, parfileref ? parfileref->fcb : NULL, &as->SubjectSecurityContext);
+
     return STATUS_SUCCESS;
 }
